#include "Common\StdAfx.h"
#include "Common\Kernel.h"
#include "Common\Audio.h"
#include "Common\Compress.h"
#include "Common\Graphics.h"
#include "Common\Parse.h"
#include "Common\Parse.h"
#include "the_application.h"
#define  GETSTRING
#include "Strings.h"
#include "MediaLib.h" /* comment out to recompile it */

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#ifndef MEDIALIB_H
#define LIBVERSION 0
signed long MediaRef [1];
#endif
#else
#ifndef MEDIALIB_H
#error MediaLib can only be created in debug mode.
#endif
#endif

const char AppName [] = " app name ",
           AppID   [] = " app id ",
           VerName [] = " 0.0 ";

void CPSocket::DeInit (void) { }
CPSocket::CPSocket    (void) { }
CPSocket::~CPSocket   (void) { }
CPSocket Socket;

void CPieterApp::HandleInit (void) {
    offset_misc = OFFSET_MISC;
    DebugMessage ("Config");
    GetRegInfo   (ExtName, LIBVERSION);
    if (runlevel != Run_Init) return;
    DebugMessage ("String table");
    InitStrTable ();
    if (runlevel != Run_Init) return;
    if (LIBVERSION == 0) {
        pack.MakeMediaLibrary (NULL);
        runlevel = Run_LogError;
        return;
    }

    /* Specific initialization */

    DebugMessage ("Graphics");
    if (Screen.Init (OFFSET_BMPS, OFFSET_JPEG, MAXJPEG)) {
        HandleProgBar (true, false);
        Screen.font = Screen.LoadSprite (Bmp_Menu);
    } else {
        runlevel = Run_ScreenError;
    }
    DebugMessage ("Audio");
    Audio.Init   (OFFSET_WAVE, OFFSET_MIDI, MAXWAVE, MAXMIDI);
    if (runlevel == Run_Init) {
        runlevel = Run_Title;
        if (CommandLine ()) {

        }
    }
}

void CPieterApp::HandleDraw (void) {
    Screen.Flip ();
}

void CPieterApp::HandleTick (void) {
}

void CPieterApp::HandleMouseMove (unsigned x, unsigned y, unsigned) {
    Screen.mousex = x;
    Screen.mousey = y;
}

void CPieterApp::HandleKeyPress (unsigned, unsigned) {
}

void CPieterApp::HandleKeyUp (unsigned, unsigned) {
}

void     CPieterApp::HandleExit       (void) {}
void     CPieterApp::HandleMouseClick (unsigned, unsigned) {}
void     CPieterApp::HandleMouseUnClk (unsigned, unsigned) {}
void     CPieterApp::HandleCoreMenu   (bool) {}
unsigned CPieterApp::HandlePTFCode    (unsigned, unsigned, unsigned) { return 0; }
void     CPieterApp::HandleMakeLib    (FILE*, FILE*) {}
void     CPieterApp::HandleRestore    (void) {}

unsigned CParser::SysCall     (unsigned)    { return 0; }
unsigned CParser::GetSpcToken (const char*) { return 0; }
unsigned CParser::Constant    (unsigned)    { return 0; }
